Index: speech.py
===================================================================
--- speech.py	(revision 2187)
+++ speech.py	(working copy)
@@ -444,6 +444,7 @@
 		userDisabledRoles.append(controlTypes.ROLE_LINK)
 	if not config.conf["virtualBuffers"]["reportLists"]:
 		userDisabledRoles.append(controlTypes.ROLE_LIST)
+		userDisabledRoles.append(controlTypes.ROLE_LISTITEM)
 	if not config.conf["virtualBuffers"]["reportHeadings"]:
 		userDisabledRoles.append(controlTypes.ROLE_HEADING)
 	if not config.conf["virtualBuffers"]["reportTables"]:
@@ -683,7 +684,8 @@
 	realStates=propertyValues.get('_states',states)
 	if states is not None:
 		positiveStates=processPositiveStates(role,realStates,reason,states)
-		textList.extend([controlTypes.speechStateLabels[x] for x in positiveStates])
+		if reason not in (REASON_SAYALL,REASON_CARET,REASON_FOCUS) or (role and role not in userDisabledRoles):
+			textList.extend([controlTypes.speechStateLabels[x] for x in positiveStates])
 		del propertyValues['states']
 	if 'negativeStates' in propertyValues:
 		negativeStates=propertyValues['negativeStates']
@@ -692,7 +694,8 @@
 		negativeStates=None
 	if negativeStates is not None or (reason != REASON_CHANGE and states is not None):
 		negativeStates=processNegativeStates(role, realStates, reason, negativeStates)
-		textList.extend([_("not %s")%controlTypes.speechStateLabels[x] for x in negativeStates])
+		if reason not in (REASON_SAYALL,REASON_CARET,REASON_FOCUS) or (role and role not in userDisabledRoles):
+			textList.extend([_("not %s")%controlTypes.speechStateLabels[x] for x in negativeStates])
 	if 'description' in propertyValues:
 		textList.append(propertyValues['description'])
 		del propertyValues['description']
@@ -700,12 +703,13 @@
 		textList.append(propertyValues['keyboardShortcut'])
 		del propertyValues['keyboardShortcut']
 	if 'positionString' in propertyValues:
-		textList.append(propertyValues['positionString'])
+		if reason not in (REASON_SAYALL,REASON_CARET,REASON_FOCUS) or (role and role not in userDisabledRoles):
+			textList.append(propertyValues['positionString'])
 		del propertyValues['positionString']
 	if 'level' in propertyValues:
 		levelNo=propertyValues['level']
 		del propertyValues['level']
-		if levelNo is not None:
+		if levelNo is not None and reason not in (REASON_SAYALL,REASON_CARET,REASON_FOCUS) or (role and role not in userDisabledRoles):
 			textList.append(_("level %s")%levelNo)
 	for name,value in propertyValues.items():
 		if not name.startswith('_') and value is not None and value is not "":
Index: virtualBuffers/__init__.py
===================================================================
--- virtualBuffers/__init__.py	(revision 2187)
+++ virtualBuffers/__init__.py	(working copy)
@@ -85,6 +85,8 @@
 		keyboardShortcutText=speech.getSpeechTextForProperties(reason=reason,keyboardShortcut=keyboardShortcut)
 		nameText=speech.getSpeechTextForProperties(reason=reason,name=name)
 		levelText=speech.getSpeechTextForProperties(reason=reason,level=level)
+		if role in speech.userDisabledRoles:
+			return None
 		if not extraDetail and ((reason==speech.REASON_FOCUS and fieldType in ("end_relative","end_inStack")) or (reason in (speech.REASON_CARET,speech.REASON_SAYALL) and fieldType in ("start_inStack","start_addedToStack","start_relative"))) and role in (controlTypes.ROLE_LINK,controlTypes.ROLE_HEADING,controlTypes.ROLE_BUTTON,controlTypes.ROLE_RADIOBUTTON,controlTypes.ROLE_CHECKBOX,controlTypes.ROLE_GRAPHIC,controlTypes.ROLE_SEPARATOR,controlTypes.ROLE_MENUITEM):
 			if role==controlTypes.ROLE_LINK:
 				return " ".join([x for x in stateText,roleText,keyboardShortcutText])
